/**
  ******************************************************************************
  * @file    Project/Template/main.c
  * @author  MCD Application Team
  * @version V1.3.0
  * @date    07/14/2010
  * @brief   Main program body
  ******************************************************************************
  * @copy
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDIN THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2010 STMicroelectronics</center></h2>
  */ 
	
/* Includes ------------------------------------------------------------------*/
#include "stm8l15x.h"
#include "discover_board.h"
#include "stm8l_discovery_lcd.h"
#include "delay.h"

/** @addtogroup Template
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
extern uint8_t t_bar[2]; // declared in stm8l_discovery_lcd.c
uint16_t itmp=0;
uint8_t bp=1;

/* Private function prototypes -----------------------------------------------*/

/* Private functions ---------------------------------------------------------*/
void mint2char(uint16_t number, uint16_t *p_tab)
{
  uint16_t units=0, tens=0, hundreds=0, thousands=0, misc=0;
  
  units = number%10;
	number/=10;
  tens = number%10;
	number/=10;
  hundreds = number%10;
	number/=10;
  thousands = number%10;
	misc=number/10;
  
  *(p_tab+4) = units + 0x30;
  *(p_tab+3) = tens + 0x30;
  *(p_tab+2) = hundreds + 0x30;
  *(p_tab+1) = thousands + 0x30;
  *(p_tab) = misc + 0x30;
}

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
void main(void)
{
	uint8_t bar=0;
  uint16_t tab[6];
	
	tab[5]='D';

	CLK_SYSCLKDivConfig(CLK_SYSCLKDiv_1);

//	EXTI_SetPinSensitivity(USER_GPIO_PIN, EXTI_Trigger_Falling);
//  GPIO_Init( BUTTON_GPIO_PORT, USER_GPIO_PIN, GPIO_Mode_In_FL_IT);
	EXTI_SetPinSensitivity(GPIO_Pin_1, EXTI_Trigger_Falling);
  GPIO_Init(GPIOC,GPIO_Pin_1, GPIO_Mode_In_FL_IT);

	GPIO_Init(LED_BLUE_PORT, LED_BLUE_PIN, GPIO_Mode_Out_PP_High_Fast);	
	GPIO_LOW(LED_BLUE_PORT,LED_BLUE_PIN);

  CLK_PeripheralClockConfig(CLK_Peripheral_TIM2, ENABLE);
	TIM2_DeInit();
  TIM2_TimeBaseInit(TIM2_Prescaler_128,TIM2_CounterMode_Up,2500);
  TIM2_UpdateRequestConfig(TIM2_UpdateSource_Global);
  TIM2_ITConfig(TIM2_IT_Update, ENABLE);
  TIM2_SelectOnePulseMode(TIM2_OPMode_Single);

	LCD_GLASS_Init();
	LCD_GLASS_DisplayString("HELLO");
	delay_ms(500);

	enableInterrupts();	
  /* Infinite loop */
  while (1)
  {
		if(bp)
		{
			bp=0;
			if(!bar) {bar=1; BAR0_ON;} else {bar=0; BAR0_OFF;}
			mint2char(itmp,tab);
			LCD_GLASS_DisplayStrDeci(tab);
//			delay_ms(50);
		}
  }
}

/**
  * @brief  Inserts a delay time.
  * @param  nCount: specifies the delay time length.
  * @retval None
  */

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */

/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/